/*
 * The contents of this file are subject to the MonetDB Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.monetdb.org/Legal/MonetDBLicense
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is the MonetDB Database System.
 *
 * The Initial Developer of the Original Code is CWI.
 * Portions created by CWI are Copyright (C) 1997-July 2008 CWI.
 * Copyright August 2008-2011 MonetDB B.V.
 * All Rights Reserved.
 */
/*
 * The contents of this file are subject to the MonetDB Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.monetdb.org/Legal/MonetDBLicense
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is the MonetDB Database System.
 *
 * The Initial Developer of the Original Code is CWI.
 * Portions created by CWI are Copyright (C) 1997-July 2008 CWI.
 * Copyright August 2008-2011 MonetDB B.V.
 * All Rights Reserved.
 */

#ifndef ALGEBRA_H
#define ALGEBRA_H

#include <gdk.h>
#include "mal_exception.h"

#ifdef WIN32
#if !defined(LIBMAL) && !defined(LIBATOMS) && !defined(LIBKERNEL) && !defined(LIBMAL) && !defined(LIBOPTIMIZER) && !defined(LIBSCHEDULER) && !defined(LIBMONETDB5)
#define algebra_export extern __declspec(dllimport)
#else
#define algebra_export extern __declspec(dllexport)
#endif
#else
#define algebra_export extern
#endif

algebra_export ptr BATmax(BAT *b, ptr aggr);
algebra_export ptr BATmin(BAT *b, ptr aggr);




algebra_export str ALGavg_bte(dbl *res, int *bid);




algebra_export str ALGavg_sht(dbl *res, int *bid);




algebra_export str ALGavg_int(dbl *res, int *bid);




algebra_export str ALGavg_wrd(dbl *res, int *bid);




algebra_export str ALGavg_lng(dbl *res, int *bid);




algebra_export str ALGavg_flt(dbl *res, int *bid);




algebra_export str ALGavg_dbl(dbl *res, int *bid);







algebra_export str ALGstdev_bte(dbl *res, int *bid);




algebra_export str ALGstdev_sht(dbl *res, int *bid);




algebra_export str ALGstdev_int(dbl *res, int *bid);




algebra_export str ALGstdev_wrd(dbl *res, int *bid);




algebra_export str ALGstdev_lng(dbl *res, int *bid);




algebra_export str ALGstdev_flt(dbl *res, int *bid);




algebra_export str ALGstdev_dbl(dbl *res, int *bid);







algebra_export str ALGsum_bte_bte(bte* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_bte_sht(sht* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_bte_int(int* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_bte_wrd(wrd* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_bte_lng(lng* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_sht_sht(sht* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_sht_int(int* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_sht_wrd(wrd* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_sht_lng(lng* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_int_int(int* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_int_wrd(wrd* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_int_lng(lng* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_wrd_wrd(wrd* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_wrd_lng(lng* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_lng_lng(lng* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_flt_flt(flt* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_flt_dbl(dbl* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_dbl_dbl(dbl* res, int *bid, bit *empty_is_nil) ;





algebra_export str ALGsum_bte_dbl(dbl* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_sht_dbl(dbl* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_int_dbl(dbl* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_wrd_dbl(dbl* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGsum_lng_dbl(dbl* res, int *bid, bit *empty_is_nil) ;





algebra_export str ALGprod_bte_bte(bte* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_bte_sht(sht* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_bte_int(int* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_bte_wrd(wrd* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_bte_lng(lng* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_sht_sht(sht* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_sht_int(int* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_sht_wrd(wrd* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_sht_lng(lng* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_int_int(int* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_int_wrd(wrd* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_int_lng(lng* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_wrd_wrd(wrd* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_wrd_lng(lng* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_lng_lng(lng* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_flt_flt(flt* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_flt_dbl(dbl* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_dbl_dbl(dbl* res, int *bid, bit *empty_is_nil) ;





algebra_export str ALGprod_bte_dbl(dbl* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_sht_dbl(dbl* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_int_dbl(dbl* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_wrd_dbl(dbl* res, int *bid, bit *empty_is_nil) ;




algebra_export str ALGprod_lng_dbl(dbl* res, int *bid, bit *empty_is_nil) ;







algebra_export str ALGmin_bte(bte* res, int *bid) ;
algebra_export str ALGmax_bte(bte* res, int *bid) ;




algebra_export str ALGmin_sht(sht* res, int *bid) ;
algebra_export str ALGmax_sht(sht* res, int *bid) ;




algebra_export str ALGmin_int(int* res, int *bid) ;
algebra_export str ALGmax_int(int* res, int *bid) ;




algebra_export str ALGmin_wrd(wrd* res, int *bid) ;
algebra_export str ALGmax_wrd(wrd* res, int *bid) ;




algebra_export str ALGmin_lng(lng* res, int *bid) ;
algebra_export str ALGmax_lng(lng* res, int *bid) ;




algebra_export str ALGmin_flt(flt* res, int *bid) ;
algebra_export str ALGmax_flt(flt* res, int *bid) ;




algebra_export str ALGmin_dbl(dbl* res, int *bid) ;
algebra_export str ALGmax_dbl(dbl* res, int *bid) ;




algebra_export str ALGminany(ptr result, int *bid);
algebra_export str ALGmaxany(ptr result, int *bid);
algebra_export str ALGtopN(int *res, int *bid, lng *top);
algebra_export str ALGgroupby(int *res, int *bid);
algebra_export str ALGcard(lng *result, int *bid);
algebra_export str ALGBATminimum(ptr *result, int *bid);
algebra_export str ALGBATmaximum(ptr *result, int *bid);
algebra_export str ALGselect1(int *result, int *bid, ptr value);
algebra_export str ALGselect1Head(int *result, int *bid, ptr value);
algebra_export str ALGuselect1(int *result, int *bid, ptr value);
algebra_export str ALGthetauselect(int *result, int *bid, ptr value, str *op);
algebra_export str ALGantiuselect1(int *result, int *bid, ptr value);
algebra_export str ALGselect(int *result, int *bid, ptr low, ptr high);
algebra_export str ALGthetaselect(int *result, int *bid, ptr low, str *op);
algebra_export str ALGselectHead(int *result, int *bid, ptr low, ptr high);
algebra_export str ALGuselect(int *result, int *bid, ptr low, ptr high);
algebra_export str ALGselectInclusive(int *result, int *bid, ptr low, ptr high, bit *lin, bit *rin);
algebra_export str ALGselectInclusiveHead(int *result, int *bid, ptr low, ptr high, bit *lin, bit *rin);
algebra_export str ALGuselectInclusive(int *result, int *bid, ptr low, ptr high, bit *lin, bit *rin);
algebra_export str ALGantiuselectInclusive(int *result, int *bid, ptr low, ptr high, bit *lin, bit *rin);
algebra_export str ALGfragment(int *result, int *bid, ptr hlow, ptr hhigh, ptr tlow, ptr thigh);
algebra_export str ALGthetajoinEstimate(int *result, int *lid, int *rid, int *opc, lng *estimate);
algebra_export str ALGthetajoin(int *result, int *lid, int *rid, int *opc);
algebra_export str ALGbandjoin_default(int *result, int *lid, int *rid, ptr *minus, ptr *plus);
algebra_export str ALGbandjoin(int *result, int *lid, int *rid, ptr *minus, ptr *plus, bit *li, bit *hi);
algebra_export str ALGrangejoin(int *result, int *lid, int *rlid, int *rhid, bit *li, bit *hi);




algebra_export str ALGhistogram(int *result, int *bid);




algebra_export str ALGnumber(int *result, int *bid);




algebra_export str ALGmerge(int *result, int *bid);




algebra_export str ALGsplit(int *result, int *bid);




algebra_export str ALGcopy(int *result, int *bid);




algebra_export str ALGkunique(int *result, int *bid);




algebra_export str ALGsunique(int *result, int *bid);




algebra_export str ALGcross(int *result, int *lid, int *rid) ;




algebra_export str ALGantijoin(int *result, int *lid, int *rid) ;




algebra_export str ALGjoinestimate(int *result, int *lid, int *rid, lng *estimate);
algebra_export str ALGjoin(int *result, int* lid, int *rid);




algebra_export str ALGfetchjoinestimate(int *result, int *lid, int *rid, lng *estimate);
algebra_export str ALGfetchjoin(int *result, int* lid, int *rid);




algebra_export str ALGleftjoinestimate(int *result, int *lid, int *rid, lng *estimate);
algebra_export str ALGleftjoin(int *result, int* lid, int *rid);




algebra_export str ALGleftfetchjoinestimate(int *result, int *lid, int *rid, lng *estimate);
algebra_export str ALGleftfetchjoin(int *result, int* lid, int *rid);




algebra_export str ALGouterjoinestimate(int *result, int *lid, int *rid, lng *estimate);
algebra_export str ALGouterjoin(int *result, int* lid, int *rid);




algebra_export str ALGsemijoin(int *result, int *lid, int *rid) ;




algebra_export str ALGsunion(int *result, int *lid, int *rid) ;




algebra_export str ALGkunion(int *result, int *lid, int *rid) ;




algebra_export str ALGsintersect(int *result, int *lid, int *rid) ;




algebra_export str ALGkintersect(int *result, int *lid, int *rid) ;




algebra_export str ALGsdiff(int *result, int *lid, int *rid) ;




algebra_export str ALGkdiff(int *result, int *lid, int *rid) ;




algebra_export str ALGsample(int *result, int* bid, int *param) ;




algebra_export str ALGtunique(int *result, int *bid);
algebra_export str ALGtsort(int *result, int *bid);
algebra_export str ALGtsort_rev(int *result, int *bid);
algebra_export str ALGhsort(int *result, int *bid);
algebra_export str ALGhsort_rev(int *result, int *bid);
algebra_export str ALGhtsort(int *result, int *lid);
algebra_export str ALGthsort(int *result, int *lid);
algebra_export str ALGssort(int *result, int *bid);
algebra_export str ALGssort_rev(int *result, int *bid);
algebra_export str ALGrevert(int *result, int *bid);
algebra_export str ALGcount_bat(wrd *result, int *bid);
algebra_export str ALGcount_nil(wrd *result, int *bid, bit *ignore_nils);
algebra_export str ALGcount_no_nil(wrd *result, int *bid);
algebra_export str ALGtmark(int *result, int *bid, oid *base);
algebra_export str ALGtmark_default(int *result, int *bid);
algebra_export str ALGtmarkp(int *result, int *bid, int *nr_parts, int *part_nr);
algebra_export str ALGmarkHead(int *result, int *bid, oid *base);
algebra_export str ALGmarkHead_default(int *result, int *bid);
algebra_export str ALGhmarkp(int *result, int *bid, int *nr_parts, int *part_nr);
algebra_export str ALGmark_grp_1(int *result, int *bid, int *gid);
algebra_export str ALGmark_grp_2(int *result, int *bid, int *gid, oid *base);
algebra_export str ALGhashsplit(int *result, int *bid, int *nfrag);
algebra_export str ALGrangesplit(int *result, int *bid, int *nfrag);
algebra_export str ALGurangesplit(int *result, int *bid, int *nfrag);
algebra_export str ALGhistogram_rev(int *result, int *bid);
algebra_export str ALGlike(int *ret, int *bid, str *k);
algebra_export str ALGslice(int *ret, bat *bid, lng *start, lng *end);
algebra_export str ALGslice_int(int *ret, bat *bid, int *start, int *end);
algebra_export str ALGslice_wrd(int *ret, bat *bid, wrd *start, wrd *end);
algebra_export str ALGposition(wrd *retval, int *bid, ptr val);
algebra_export str ALGpositionBUN(wrd *retval, int *bid, ptr val, ptr tval);
algebra_export str doALGfetch(ptr ret, BAT *b, lng *pos);
algebra_export str ALGfetch(ptr ret, int *bid, lng *pos);
algebra_export str ALGfetchoid(int *ret, int *bid, oid *pos);
algebra_export str ALGfetchint(int *ret, int *bid, int *pos);
algebra_export str ALGfetchbat(int *ret, int *bid, int *sid);
algebra_export str ALGexist(bit *ret, int *bid, ptr val);
algebra_export str ALGexistBUN(bit *ret, int *bid, ptr val, ptr tval);
algebra_export str ALGfind(ptr ret, int *bid, ptr val);
algebra_export str ALGhashjoin(int *result, int *lid, int *rid);
algebra_export str ALGmergejoin(int *result, int *lid, int *rid);
algebra_export str ALGindexjoin(int *result, int *lid, int *rid);
algebra_export str ALGprojectNIL(int *ret, int *bid);
algebra_export str ALGselectNotNil(int *result, int *bid);
algebra_export str ALGuhashsplit(int *result, int *bid, int *nfrag);




algebra_export str ALGprojecthead_int(int *ret,ptr *val, int *bid);
algebra_export str ALGprojecttail_int(int *ret,int *bid, ptr *val);




algebra_export str ALGprojecthead_sht(int *ret,ptr *val, int *bid);
algebra_export str ALGprojecttail_sht(int *ret,int *bid, ptr *val);




algebra_export str ALGprojecthead_lng(int *ret,ptr *val, int *bid);
algebra_export str ALGprojecttail_lng(int *ret,int *bid, ptr *val);




algebra_export str ALGprojecthead_oid(int *ret,ptr *val, int *bid);
algebra_export str ALGprojecttail_oid(int *ret,int *bid, ptr *val);




algebra_export str ALGprojecthead_flt(int *ret,ptr *val, int *bid);
algebra_export str ALGprojecttail_flt(int *ret,int *bid, ptr *val);




algebra_export str ALGprojecthead_dbl(int *ret,ptr *val, int *bid);
algebra_export str ALGprojecttail_dbl(int *ret,int *bid, ptr *val);




algebra_export str ALGprojecthead_str(int *ret,ptr *val, int *bid);
algebra_export str ALGprojecttail_str(int *ret,int *bid, ptr *val);




algebra_export str ALGprojecthead_chr(int *ret,ptr *val, int *bid);
algebra_export str ALGprojecttail_chr(int *ret,int *bid, ptr *val);




algebra_export str ALGprojecthead_bit(int *ret,ptr *val, int *bid);
algebra_export str ALGprojecttail_bit(int *ret,int *bid, ptr *val);




algebra_export str ALGidentity(int *ret, int *bid);
algebra_export str ALGmaterialize(int *ret, int *bid);
algebra_export str ALGreuse(int *ret, int *bid);
#endif


#define BATtdiff(l,r) BATmirror(BATkdiff(BATmirror(l),BATmirror(r)))
#define BATtintersect(l,r) BATmirror(BATkintersect(BATmirror(l),BATmirror(r)))
#define BATtsort(b) BATmirror(BATsort(BATmirror(b)))
#define BATtsort_rev(b) BATmirror(BATsort_rev(BATmirror(b)))
#define BAThistogram_rev(b) BAThistogram(BATmirror(b))
#define BATmark_default(b) BATmark(b,OIDnew(BATcount(b)))
#define BATtmark_default(b) BATmirror(BATmark(BATmirror(b),OIDnew(BATcount(b))))
#define BAThmark_default(b) BATmirror(BATmark(b,OIDnew(BATcount(b))))
#define BATwcopy(b) BATcopy(b, b->htype, b->ttype, 1)
#define BATrcopy(b) BATcopy(b, b->htype, b->ttype, 2)

