/*
 * The contents of this file are subject to the MonetDB Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.monetdb.org/Legal/MonetDBLicense
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is the MonetDB Database System.
 *
 * The Initial Developer of the Original Code is CWI.
 * Portions created by CWI are Copyright (C) 1997-July 2008 CWI.
 * Copyright August 2008-2011 MonetDB B.V.
 * All Rights Reserved.
 */

/*
 * @+ Implementation Code
 * Inclusion of the xtables requires some preliminary definitions
 * and als renaming :group by something else, because Mx can;t handle
 * macros identical to file names.
 */
#ifndef _GROUP_H_
#define _GROUP_H_
#include "gdk.h"

#ifdef WIN32
#if !defined(LIBMAL) && !defined(LIBATOMS) && !defined(LIBKERNEL) && !defined(LIBMAL) && !defined(LIBOPTIMIZER) && !defined(LIBSCHEDULER) && !defined(LIBMONETDB5)
#define group_export extern __declspec(dllimport)
#else
#define group_export extern __declspec(dllexport)
#endif
#else
#define group_export extern
#endif

group_export str GRPprelude(void);
group_export str GRPgroup_custom(int *rethisto, int *retbid, int *bid, int *N, int *rng);
group_export str GRPgroup(int *rethisto, int *retbid, int *bid);
group_export str GRPgroup0(int *ret, int *bid, int *start, int *incr, int *grpsize);
group_export str GRPderive(int *hid, int *mid, int *ct_histoid, int *ct_mapid, int *bid);
group_export str GRPrefine(int *retid, int *bid, int *aid);
group_export str GRPrefine_rev(int *retid, int *bid, int *aid);

/* used by rdf_shredder.mx */
group_export int CTrefine(BAT **res, BAT *b, BAT *a);
group_export int CTrefine_rev(BAT **res, BAT *b, BAT *a);

#endif /* _GROUP_H_ */

